#include "testlib.h"

using namespace std;

int n, k;
bool equidist;

int gen_spiral(int q, int size) {
    static vector<char> const d{'N', 'W', 'S', 'E'};
    int cnt = 0;
    while (q > 0) {
        for (int i = 0; i < q; i++) {
            int a = equidist ? k : max(rnd.wnext(size / 2, size, 2), 1);
            println(d[i % 4], a);
        }
        cnt += q;
        q--;
    }
    return cnt;
}

int gen_grid(int q, int size) {
    int half = 2 * q, cnt = 0;
    while (half % 4 != 3) half++;

    static vector<char> const d1{'N', 'W', 'S', 'W'};
    for (int col = 0; col < half; col++) {
        int iter = col % 2 == 0 ? q : 1;
        for (int i = 0; i < iter; i++) {
            int a = equidist ? k : max(1, rnd.wnext(size / 2, size, 2));
            println(d1[col % 4], a);
        }
        cnt += iter;
    }
    static vector<char> const d2{'E', 'N', 'W', 'N'};
    for (int row = 0; row < half; row++) {
        int iter = row % 2 == 0 ? q : 1;
        for (int i = 0; i < iter; i++) {
            int a = equidist ? k : max(1, rnd.wnext(size / 2, size, 2));
            println(d2[row % 4], a);
        }
        cnt += iter;
    }

    return cnt;
}

void gen_rnd(int cnt, int size) {
    static vector<char> const d{'N', 'W', 'S', 'E'};
    for (int i = 0; i < cnt; i++) {
        int a = equidist ? k : rnd.next(1, size);
        println(d[rnd.next(d.size())], a);
    }
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    k = opt<int>("k"), n = opt<int>("n");
    equidist = has_opt("equidist");
    int alim = equidist ? -1 : opt<int>("alim");

    int spiral = opt<double>("spiral") * n,
            grid = opt<double>("grid") * n;

    println(k, n);

    if (spiral > 0) {
        n -= gen_spiral(sqrt(2 * spiral), alim);
    }
    if (grid > 0) {
        n -= gen_grid(sqrt(grid / 8), alim);
    }
    gen_rnd(n, alim);

}