#include "testlib.h"

int main(int argc, char** argv) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int maxVectorCoord = atoi(argv[2]);
	int maxCoord = atoi(argv[3]);
	double noise = atof(argv[4]);
	int needShuffle = atoi(argv[5]);
	int type = atoi(argv[6]);

	int startX = rnd.next(-maxVectorCoord, maxVectorCoord);
	int startY = rnd.next(-maxVectorCoord, maxVectorCoord);

	int dx = rnd.next(-maxVectorCoord, maxVectorCoord);
	int dy = rnd.next(-maxVectorCoord, maxVectorCoord);
	if (type == 0) {
		dx = 0;
	} else {
		dy = 0;
	}
	while (dx == 0 && dy == 0) {
	    dx = rnd.next(-maxVectorCoord, maxVectorCoord);
        dy = rnd.next(-maxVectorCoord, maxVectorCoord);
        if (type == 0) {
			dx = 0;
		} else {
			dy = 0;
		}
	}

	std::set<std::pair<int, int>> setik;
	while ((double)setik.size() < (double)n * (1.0 - noise)) {
		int t = rnd.next(-(maxCoord / maxVectorCoord), (maxCoord / maxVectorCoord));
		int x = startX + t * dx;
		int y = startY + t * dy;
		setik.emplace(x, y);
	}

	while ((int)setik.size() != n) {
		int x = rnd.next(-maxCoord, maxCoord);
		int y = rnd.next(-maxCoord, maxCoord);
		setik.emplace(x, y);
	}

	std::vector<std::pair<int, int>> points(setik.begin(), setik.end());
	if (needShuffle == 1) {
		shuffle(points.begin(), points.end());
	}

    int k = rnd.next(0, n - 2) + 1;
	std::cout << n << ' ' << k << std::endl;
	for (auto[x, y] : points) {
		std::cout << x << ' ' << y << std::endl;
	}

	return 0;
}