using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

using ull = unsigned long long;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");

    ull max_z = has_opt("z") ? opt<ull>("z") : 1'000'000'000ULL;
    ull max_p = has_opt("p") ? opt<ull>("p") : 1e18;
    ull max_ab = has_opt("a") ? opt<ull>("a") : 1'000'000'000ULL;

    int n = max_n == 1 ? 1 : (1 + rnd.wnext(max_n, 5));
    ull p = 1 + rnd.wnext(max_p, 3);
    printf("%d %llu\n", n, p);

    ull z = rnd.next(1ULL, max_z);
    ull a = rnd.next(1ULL, max_ab);
    ull b = rnd.next(1ULL, max_ab);

    for (int i = 0; i < n; ++i) {
        printf("%llu %llu %llu\n", z, a, b);
    }
}

