#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

using ull = unsigned long long;

const int max_n = 100;
const int max_ab = 10'000;
const int max_z = 1'000'000'000;
const ull max_p = 1'000'000'000'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readSpace();
    ull p = inf.readUnsignedLong(1, max_p, "p");
    inf.readEoln();
    vector<ull> z(n), a(n), b(n);
    for (int i = 0; i < n; ++i) {
        z[i] = inf.readUnsignedLong(1, max_z, "z_i");
        inf.readSpace();
        a[i] = inf.readUnsignedLong(1, max_ab, "a_i");
        inf.readSpace();
        b[i] = inf.readUnsignedLong(1, max_ab, "b_i");
        inf.readEoln();
    }
    inf.readEof();

    if (validator.group() == "1") {
        ensuref(n == 1, "g1. n must be eq 1");
    } else if (validator.group() == "2") {
        ensuref(p <= 100'000, "g2. p must be leq 10^5");
        for (int i = 0; i < n; ++i) {
            ensuref(a[i] <= 100, "g2. a[i] must be leq 100");
            ensuref(b[i] <= 100, "g2. b[i] must be leq 100");
        }
    } else if (validator.group() == "3") {
        for (int i = 1; i < n; ++i) {
            ensuref(z[i] == z[0], "g3. all z[i] must be eq");
        }
    } else if (validator.group() == "4") {
        ensuref(n <= 2, "g4. n must be leq 2");
    } else if (validator.group() != "5" && validator.group() != "0") {
//        ensuref(false, "unknown group");
    }
}