#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define fastInp ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const ll N = 3010, INF = 1e9;

vector<ll> perm;
ll calc[N][N];

int main() {
	fastInp;
	
	int n, q;
	cin >> n >> q;

	perm.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> perm[i];
	}

	for (int i = 0; i < n; i++) {
		pair<int, int> cur = { i, i };

		int iter = 1;
		calc[i][iter]++;

		while (cur != make_pair(0, n - 1)) {
			iter++;
			ll v1 = INF, v2 = INF;
			if (cur.first > 0) v1 = perm[cur.first - 1];
			if (cur.second < n - 1) v2 = perm[cur.second + 1];

			if (v1 < v2) {
				cur.first--;
				calc[cur.first][iter]++;
			} else {
				cur.second++;
				calc[cur.second][iter]++;
			}
		}
	}

	while (q--) {
		ll p, k;
		cin >> p >> k;

		p--;
		cout << calc[p][k] << "\n";
	}

	return 0;
}