#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int MOD = 1e9+7;
const int N = 1e6+7;

int fact[N+1], rfct[N+1];

int rev(int a, int m = MOD) {
    return a == 1 ? 1 : m - (ll)m*rev(m%a, a)/a;
}

int C(int n, int k) {
    if (k < 0 || k > n) return 0;
    return (ll)fact[n]*rfct[k]%MOD*rfct[n-k]%MOD;
}

int Balls(int box, int balls) {
    if (balls == 0) return 1;
    return C(balls+box-1, balls);
}

int solve_start_a(const string& s) {
    if (s.front() != s.back() && s.front() != 'a') return 0;
    if (s.size() == 1) return 1;
    if (find(s.begin(), s.end(), 'a') == s.end()) return 0;

    array<int, 3> cnt, dob;
    fill(cnt.begin(), cnt.end(), 0);
    fill(dob.begin(), dob.end(), 0);
    int KAB = 0, kCB = 0;

    cnt[0]++;
    for (int i = 0; i + 1 < s.size(); ++i) {
        if (s[i] == s[i+1]) {
            dob[s[i+1] - 'a']++;
        } else {
            cnt[s[i+1] - 'a']++;
        }

        if (s[i] == 'a' && s[i+1] == 'b') ++KAB;
        if (s[i] == 'c' && s[i+1] == 'b') ++kCB;
    }

    ll res = Balls(KAB, kCB);
    for (int z = 0; z < 3; ++z) {
        res = res * Balls(cnt[z], dob[z]) % MOD;
    }

    return res;
}

int solve_start_b(const string& s) {
    if (s.front() != s.back() && s.front() != 'b') return 0;
    if (s.size() == 1) return 1;
    if (find(s.begin(), s.end(), 'b') == s.end()) return 0;

    array<int, 3> cnt, dob;
    fill(cnt.begin(), cnt.end(), 0);
    fill(dob.begin(), dob.end(), 0);
    int kAB = 0, kCB = 0;

    cnt[1]++;
    for (int i = 0; i + 1 < s.size(); ++i) {
        if (s[i] == s[i+1]) {
            dob[s[i+1] - 'a']++;
        } else {
            cnt[s[i+1] - 'a']++;
        }
        if (s[i] == 'a' && s[i+1] == 'b') ++kAB;
        if (s[i] == 'c' && s[i+1] == 'b') ++kCB;
    }

    ll res = C(kAB + kCB, kAB);
    for (int z = 0; z < 3; ++z) {
        res = res * Balls(cnt[z], dob[z]) % MOD;
    }
    return res;
}

void solve() {
    string s; cin >> s;

    ll res = solve_start_a(s) + solve_start_b(s);
    for (char& ch : s) {
        if (ch != 'b') ch ^= 'a' ^ 'c';
    }
    res += solve_start_a(s);
    cout << res % MOD << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    fact[0] = 1;
    for (int i = 1; i <= N; ++i) fact[i] = (ll)fact[i-1]*i%MOD;
    rfct[N] = rev(fact[N]);
    for (int i = N; i >= 1; --i) rfct[i-1] = (ll)rfct[i]*i%MOD;

    int g; cin >> g;
    int t; cin >> t;
    while (t--) {
        solve();
    }
}